#include <cstdio>
#include <cstdlib>

#include "gg.h"

/*
** _̐
*/
#define POINTS 100000

/*
** VF[_
*/
#include "shader.h"
static GLuint shader;

/*
** ϊs
*/
#include "Matrix.h"
static Matrix projectionMatrix;
static Matrix modelviewMatrix;
static GLint transformMatrixLocation;

/*
** _
*/
static GLuint buffer[2];
static GLint pointLocation;

/*
**gbN{[
*/
#include "Trackball.h"
static Trackball trackball;

/*
** ʕ\
*/
static void display(void)
{
  static int frame = 0;
  //GLuint query, primitives_written = 0;

  // ʃNA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // VF[_vO̓Kp
  glUseProgram(shader);

  // uniform ϐ transformMatrix ɕϊsݒ
  Matrix transformMatrix = projectionMatrix * modelviewMatrix * trackball.get();
  glUniformMatrix4fv(transformMatrixLocation, 1, GL_FALSE, transformMatrix.get());

  // attribute ϐ point ɒ_ݒ
  glEnableVertexAttribArray(pointLocation);

  // ڂ̒_obt@IuWFNgw
  glBindBuffer(GL_ARRAY_BUFFER, buffer[frame]);

  // _̊i[ꏊƏw
  glVertexAttribPointer(pointLocation, 3, GL_FLOAT, GL_FALSE, 0, 0);

  // ڂ̒_obt@IuWFNg^[QbgƂĎw
  glBindBufferBase(GL_TRANSFORM_FEEDBACK_BUFFER, 0, buffer[1 - frame]);

  // Transform Feedback Jn
  //glBeginQuery(GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, query);
  glBeginTransformFeedback(GL_POINTS);

  // }`̕`
  glDrawArrays(GL_POINTS, 0, POINTS);

  // Transform Feedback I
  glEndTransformFeedback();
  //glEndQuery(GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN);
  //glGetQueryObjectuiv(query, GL_QUERY_RESULT, &primitives_written);
  //printf("%d, %d\n", frame, primitives_written);

  // _obt@IuWFNg̎w̉
  glBindBuffer(GL_ARRAY_BUFFER, 0);

  // attribute ϐ point ̒_̐ݒ
  glDisableVertexAttribArray(pointLocation);

  // VF[_vO̎w̉
  glUseProgram(0);

  // _obt@IuWFNg̃_uobt@O
  frame = 1 - frame;

  // _uobt@O
  glutSwapBuffers();
}

/*
** EBhETCY
*/
static void resize(int w, int h)
{
  // r[|[g̓EBhES
  glViewport(0, 0, w, h);

  // eϊs
  projectionMatrix.loadPerspective(DEG_TO_RAD(30.0f), (GLfloat)w / (GLfloat)h, 3.0f, 7.0f);

  // gbN{[͈
  trackball.region(w, h);
}

/*
** L[{[h
*/
static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
    // ESC, q, Q ̃^CvŏI
    case '\033':
    case 'q':
    case 'Q':
      exit(0);
    default:
      break;
  }
}

/*
** Aj[V
*/
static void idle(void)
{
  // ʂ̕`ւ
  glutPostRedisplay();
}

/*
** Ă}EX̃{^
*/
static int pressed;

/*
** }EX̃NbN
*/
static void mouse(int button, int state, int x, int y)
{
  switch (pressed = button) {
    case GLUT_LEFT_BUTTON:
      if (state == GLUT_DOWN) {
        // gbN{[Jn
        trackball.start(x, y);
      }
      else {
        // gbN{[~
        trackball.stop(x, y);
      }
      break;
    default:
      break;
  }
}

/*
** }EX̃hbO
*/
static void motion(int x, int y)
{
  switch (pressed) {
    case GLUT_LEFT_BUTTON:
      // gbN{[ړ
      trackball.motion(x, y);
      break;
    default:
      break;
  }
}

/*
** 
*/
static void init(void)
{
  // Q[OtBbNX_̓sɂƂÂ
  ggInit();

  // VF[_[̃\[Xt@C̓ǂݍ
  shader = loadShader("simple.vert", "simple.frag");

  // uniform ϐ transformMatrix ̏ꏊ̎擾
  transformMatrixLocation = glGetUniformLocation(shader, "transformMatrix");

  // attribute ϐ point ̏ꏊ̎擾
  pointLocation = glGetAttribLocation(shader, "point");

  // ϊs̐ݒ
  modelviewMatrix.loadLookat(0.0f, 0.0f, 5.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f);

  // _obt@IuWFNg̍쐬
  glGenBuffers(sizeof buffer / sizeof buffer[0], buffer);

  // ڂ̒_obt@IuWFNg
  glBindBuffer(GL_ARRAY_BUFFER, buffer[0]);

  // ڂ̒_obt@IuWFNg̃m
  glBufferData(GL_ARRAY_BUFFER, sizeof (GLfloat[3]) * POINTS, 0, GL_STATIC_DRAW);

  // ڂ̒_obt@IuWFNg̃vÕԂɃ}bv
  GLfloat (*point)[3] = (GLfloat (*)[3])glMapBuffer(GL_ARRAY_BUFFER, GL_WRITE_ONLY);

  // _̏ʒu̐ݒ
  for (int i = 0; i < POINTS; ++i) {
    point[i][0] = 2.0f * (float)rand() / (float)RAND_MAX - 1.0f;
    point[i][1] = 2.0f * (float)rand() / (float)RAND_MAX - 1.0f;
    point[i][2] = 2.0f * (float)rand() / (float)RAND_MAX - 1.0f;
  }

  // ڂ̒_obt@IuWFNg̃vÕԂA}bv
  glUnmapBuffer(GL_ARRAY_BUFFER);

  // ڂ̒_obt@IuWFNg
  glBindBuffer(GL_ARRAY_BUFFER, buffer[1]);

  // ڂ̒_obt@IuWFNg̃m
  glBufferData(GL_ARRAY_BUFFER, sizeof (GLfloat[3]) * POINTS, 0, GL_STATIC_DRAW);

  // _obt@IuWFNg̎w̉
  glBindBuffer(GL_ARRAY_BUFFER, 0);

  // wiF̐ݒ
  glClearColor(0.0f, 0.1f, 0.3f, 1.0f);

  // Bʏ̗L
  glEnable(GL_DEPTH_TEST);
}

/*
** CvO
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutIdleFunc(idle);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();

  return 0;
}
